using Jypeli;

namespace HirsipuuPeli;

/// @author vesal
/// @version 27.10.2024
/// <summary>
/// </summary>
public class Hirsipuu : PhysicsGame
{
    private static readonly string[] kirjaimet =
    {
        "QWERTYUIOPÅ",
        "ASDFGHJKLÖÄ",
        "ZXCVBNM -"
    };    
    
    
    public override void Begin()
    {
        Level.Background.CreateGradient(Color.Brown, Color.Black);

        Aakkoset aakkoset = new Aakkoset(this, kirjaimet, new Vector(-200, 0), 800);
        Camera.ZoomToAllObjects();
        
        PhoneBackButton.Listen(ConfirmExit, "Lopeta peli");
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
    }
}


public class Aakkoset
{
    public Aakkoset(Game peli, string[] kirjaimet, Vector p, double w)
    {
        if (kirjaimet.Length == 0) return;
        int n = kirjaimet[0].Length;  // TODO: etsi pisin rivi
        if (n == 0) return;
        double d = w / n;
        Vector koko = new Vector(d, d);
        Vector rivisiirtyma = new Vector(d*0.2, -d*1.1);
        Vector sarakesiirtyma = new Vector(d*1.1, 0);

        for (int rivi = 0; rivi < kirjaimet.Length; rivi++)
        {
            Vector paikka = p + rivi * rivisiirtyma;
            string jono = kirjaimet[rivi];
            for (int sarake = 0; sarake < jono.Length; sarake++)
            {
                char kirjain = jono[sarake];
                Kirjain palikka = new Kirjain(peli, kirjain, paikka, koko);
                paikka += sarakesiirtyma;
            }
        }
    }

}

public class Kirjain : PhysicsObject // IS-A sääntö vs HAS-A sääntö.  Kissa on Elain!
{
    public Kirjain(Game peli, char k,  Vector p, Vector koko) : base(koko.X, koko.Y)
    {
        peli.Add(this);
        
        this.Position = p;

        Label label = new Label(""+k);
        this.Add(label);
        label.RelativePosition = Vector.Zero;

        Font fontti = new Font(70, true);
        label.Font = fontti;
        this.Image = Game.LoadImage("puupalikka");
    }
}

